/**
 *	@file    pubkey_openssl.h
 *	@version 955a8d5 (HEAD -> master, origin/master, origin/HEAD)
 *
 *	OpenSSL Layer for RSA, DH and ECC.
 */
/*
 *	Copyright (c) 2013-2016 INSIDE Secure Corporation
 *	Copyright (c) PeerSec Networks, 2002-2011
 *	All Rights Reserved
 *
 *	The latest version of this code is available at http://www.matrixssl.org
 *
 *	This software is open source; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This General Public License does NOT permit incorporating this software
 *	into proprietary programs.  If you are unable to comply with the GPL, a
 *	commercial license for this software may be purchased from INSIDE at
 *	http://www.insidesecure.com/
 *
 *	This program is distributed in WITHOUT ANY WARRANTY; without even the
 *	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	http://www.gnu.org/copyleft/gpl.html
 */
/******************************************************************************/

#ifndef _h_OPENSSL_PUBKEY
#define _h_OPENSSL_PUBKEY

/******************************************************************************/
#ifdef USE_OPENSSL_RSA

	#include <openssl/rsa.h>

/*
	typedef struct	 {
		BIGNUM *n;              // public modulus
		BIGNUM *e;              // public exponent
		BIGNUM *d;              // private exponent
		BIGNUM *p;              // secret prime factor
		BIGNUM *q;              // secret prime factor
		BIGNUM *dmp1;           // d mod (p-1)
		BIGNUM *dmq1;           // d mod (q-1)
		BIGNUM *iqmp;           // q^-1 mod p
		// ...
	 } RSA;
 */
	/** @note This type is a pointer, not the actual RSA structure */
	typedef RSA* psRsaKey_t;

	#define PS_RSA_STATIC_INIT  NULL

#endif

/******************************************************************************/

#endif /* _h_OPENSSL_PUBKEY */

